#include <bits/stdc++.h>
using namespace std;

typedef long long cat;

cat mod =1000000009;
double eps =1e-10;

cat pw(cat a, cat e) {
	if(e <= 0) return 1;
	cat x =pw(a,e/2);
	x =(x*x)%mod;
	if(e&1) x =(x*a)%mod;
	return x;}

void solveL(int N, int C, int K, auto &prob) {
	cat invC =pw(C,mod-2);
	prob[0][0] =1;
	for(int i =1; i < N; i++) {
		int n =i+1;
		cat p =(i*invC)%mod;
		vector<cat> p_suc(n,0);
		for(int j =1; j < n; j++) 
			p_suc[j] =(p*prob[i-1][j%(n-1)])%mod;
		vector<bool> vis(n,0);
		for(int j =0; j < n; j++) if(!vis[j]) {
			vector<int> cyc(1,j);
			cat p_tot =0;
			while(true) {
				int nxt =(cyc.back()+K)%n;
				if(nxt == j) break;
				cyc.push_back(nxt);}
			for(int k =cyc.size()-1; k >= 0; k--) {
				p_tot =(p_tot*(1-p)+p_suc[cyc[k]])%mod;
				vis[cyc[k]] =true;}
			cat denom =(1-pw(1-p,cyc.size()))%mod;
			p_tot =(p_tot*pw(denom,mod-2))%mod;
			prob[i][j] =p_tot;
			for(int k =cyc.size()-1; k > 0; k--) 
				prob[i][cyc[k]] =(prob[i][cyc[(k+1)%cyc.size()]]*(1-p)+p_suc[cyc[k]])%mod;
			}
		}
	}

void solveD(int N, int C, int K, auto &prob) {
	prob[0][0] =1;
	for(int i =1; i < N; i++) {
		int n =i+1;
		double p =1.0*i/C;
		vector<double> p_suc(n,0);
		for(int j =1; j < n; j++) 
			p_suc[j] =p*prob[i-1][j%(n-1)];
		vector<bool> vis(n,0);
		for(int j =0; j < n; j++) if(!vis[j]) {
			vector<int> cyc(1,j);
			double p_tot =0;
			while(true) {
				int nxt =(cyc.back()+K)%n;
				if(nxt == j) break;
				cyc.push_back(nxt);}
			for(int k =cyc.size()-1; k >= 0; k--) {
				p_tot =p_tot*(1-p)+p_suc[cyc[k]];
				vis[cyc[k]] =true;}
			p_tot /=1-pow(1-p,cyc.size());
			prob[i][j] =p_tot;
			for(int k =cyc.size()-1; k > 0; k--) 
				prob[i][cyc[k]] =prob[i][cyc[(k+1)%cyc.size()]]*(1-p)+p_suc[cyc[k]];
			}
		}
	}

int main() {
	cout << fixed << setprecision(10);
	int T;
	cin >> T;
	for(int t =0; t < T; t++) {
		int N,C,K;
		cin >> N >> C >> K;
		if(N == 1) {
			cout << "0 1\n";
			continue;}
		vector< vector<double> > probD(N,vector<double>(N,0));
		solveD(N,C,K,probD);
		double prob_opt =-1;
		int pos_opt;
		for(int i =0; i < N; i++) if(probD[N-1][i] > prob_opt+eps) {
			prob_opt =probD[N-1][i];
			pos_opt =i;}
		bool unique =true;
		for(int i =0; i < N; i++) if(i != pos_opt)
			if(abs(probD[N-1][i]-prob_opt) < eps) unique =false;
		assert(unique && pos_opt);
		vector< vector<cat> > probL(N,vector<cat>(N,0));
		solveL(N,C,K,probL);
		if(probL[N-1][pos_opt] < 0) probL[N-1][pos_opt] +=mod;
		cout << N-pos_opt << " " << probL[N-1][pos_opt] << "\n";}
	}
